# 运行DragonBoat示例

## 环境准备

### 安装Go

在运行DragonBoat示例之前，需要先安装Go语言环境。

#### Ubuntu 22.04 ARM64
```sh
$ sudo apt install golang
$ go version
go version go1.18.1 linux/arm64
```

#### macOS
访问[Go官方网站](https://go.dev/dl/)下载安装包并安装。
```sh
% go version
go version go1.22.2 darwin/arm64
```

#### Debian 11
```sh
$ sudo apt install golang
$ go version
go version go1.15.15 linux/arm64
# 版本过低，后续操作可能会出错
# 按照教程从官网下载安装最新版本
$ sudo apt remove golang
$ sudo tar -zxvf go1.22.2.linux-amd64.tar.gz -C /usr/local
$ export PATH=/usr/local/go/bin:$PATH
```

### 运行DragonBoat示例

#### 获取DragonBoat示例代码

先不管Get_Started的`go get github.com/lni/dragonboat/v3@latest`命令，这条命令会在Go项目中引入一个新的依赖项或更新一个已存在的依赖项，项目内需要有`go.mod`文件。

#### 运行示例

DragonBoat示例代码的详细运行教程请参考以下链接：
- [DragonBoat示例代码主页](https://github.com/lni/dragonboat-example/blob/master/README.CHS.md)
- [HelloWorld示例](https://github.com/lni/dragonboat-example/tree/master/helloworld)

##### 步骤：

1. 克隆示例代码仓库：
```sh
git clone https://github.com/lni/dragonboat-example.git
cd dragonboat-example
```

2. 根据教程运行示例程序：
   - 在同一台电脑上打开多个终端运行。如果在不同电脑上运行可能会出现无法连接的问题，因为所有的IP都是`127.0.0.1`的不同端口。
   - 本地回环示例：
   ![截屏2024-04-13 10.48.22.png](https://gitlab.eduxiji.net/T202410558992662/project2210132-233629/-/raw/main/images/dragonboat_study_1.png?inline=false)
   
   即可跑出，其他demo省略。

   ![截屏2024-04-13 11.30.45.png](https://gitlab.eduxiji.net/T202410558992662/project2210132-233629/-/raw/main/images/dragonboat_study_2.png?inline=false)

3. 对于`example-multigroup`示例，指令需要修改如下：
```sh
./example-multigroup -nodeid 1
```

## 参考链接

- [DragonBoat项目主页](https://github.com/lni/dragonboat)
- [DragonBoat示例代码主页](https://github.com/lni/dragonboat-example/blob/master/README.CHS.md)
- [HelloWorld示例](https://github.com/lni/dragonboat-example/tree/master/helloworld)

